ScoreboardSummary_Version = 1.5

-- PLAYER FRAME
SSumFrame = CreateFrame("Frame", "SSumFrame", UIParent)
SSumFrame:SetWidth(650) SSumFrame:SetHeight(130)
SSumFrame:SetMovable(true); SSumFrame:EnableMouse(true)
SSumFrame:SetParent("WorldStateScoreFrame")

if not SSumFrame:IsUserPlaced() then
    SSumFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 330)
    SSumFrame:SetUserPlaced(1)
end

SSumFrame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
                                            edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
                                            insets = { left = 5, right = 6, top = 6, bottom = 5 }})
local back = SSumFrame:CreateTexture(nil, "BACKGROUND")
back:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
back:SetPoint("TOPLEFT", "SSumFrame","TOPLEFT", 11, -12)
back:SetPoint("BOTTOMRIGHT", "SSumFrame","BOTTOMRIGHT", -12, 11)
back:SetGradient("VERTICAL", .1, .1, .1, .45, .45, .45)

-- HEADER
SSumFrame.header = CreateFrame("Frame", "SSumFrame", UIParent)
SSumFrame.header:SetFrameStrata("BACKGROUND")
SSumFrame.header:SetParent("SSumFrame")
SSumFrame.header:SetWidth(650) SSumFrame.header:SetHeight(33)
SSumFrame.header:SetPoint("CENTER", SSumFrame, "TOP", 0, 0)
SSumFrame.header:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
                                            edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", 
                                            tile = true, tileSize = 25, edgeSize = 25, 
                                            insets = { left = 5, right = 6, top = 6, bottom = 5 }});
SSumFrame.headertext = SSumFrame.header:CreateFontString(nil, "BACKGROUND")
SSumFrame.headertext:SetFontObject(GameFontNormalSmall)
SSumFrame.headertext:SetWidth(650) SSumFrame.headertext:SetHeight(25)
SSumFrame.headertext:SetPoint("CENTER", SSumFrame.header, "CENTER", 0, 0)
SSumFrame.headertext:SetJustifyH("MIDDLE") SSumFrame.headertext:SetJustifyV("MIDDLE")
SSumFrame.headertext:SetText("|cffffffffScoreboard Summary v|cffffd200".. ScoreboardSummary_Version)

-- HOOK EVENTS
SSumFrame:RegisterEvent("ADDON_LOADED")
SSumFrame:RegisterEvent("UPDATE_BATTLEFIELD_SCORE")
SSumFrame:SetScript("OnEvent", function() ScoreboardSummary_OnEvent(event, arg1) end)
SSumFrame:SetScript("OnUpdate", function() ScoreboardSummary_OnUpdate() end)
SSumFrame:SetScript("OnMouseDown", function() SSumFrame:StartMoving() end)
SSumFrame:SetScript("OnMouseUp", function() SSumFrame:StopMovingOrSizing() end)
SSumFrame:SetScript("OnDragStop", function() SSumFrame:StopMovingOrSizing() end)
SSumFrame:SetScript("OnEnter", function() GameTooltip:SetOwner(this, "ANCHOR_RIGHT"); GameTooltip:SetText("Left-click to drag.\n/ssum playerName") end)
SSumFrame:SetScript("OnLeave", function() GameTooltip:Hide() end)

-- TEXT AREA
SSumText1 = SSumFrame:CreateFontString(nil, "BACKGROUND")
SSumText1:SetFontObject(GameFontNormalSmall)
SSumText1:SetWidth(200) SSumText1:SetHeight(130)
SSumText1:SetPoint("TOPLEFT", SSumFrame, "TOPLEFT", 15, -15)
SSumText1:SetJustifyH("LEFT") SSumText1:SetJustifyV("TOP")
SSumText1:SetParent("SSumFrame")

SSumText10 = SSumFrame:CreateFontString(nil, "BACKGROUND")
SSumText10:SetFontObject(GameFontNormalSmall)
SSumText10:SetWidth(200) SSumText10:SetHeight(130)
SSumText10:SetPoint("TOPLEFT", SSumFrame, "TOPLEFT", 0, -15)
SSumText10:SetJustifyH("RIGHT") SSumText10:SetJustifyV("TOP")
SSumText10:SetParent("SSumFrame")

SSumText2 = SSumFrame:CreateFontString(nil, "BACKGROUND")
SSumText2:SetFontObject(GameFontNormalSmall)
SSumText2:SetWidth(200) SSumText2:SetHeight(130)
SSumText2:SetPoint("TOPLEFT", SSumFrame, "TOPLEFT", 215, -15)
SSumText2:SetJustifyH("LEFT") SSumText2:SetJustifyV("TOP")
SSumText2:SetParent("SSumFrame")

SSumText20 = SSumFrame:CreateFontString(nil, "BACKGROUND")
SSumText20:SetFontObject(GameFontNormalSmall)
SSumText20:SetWidth(200) SSumText20:SetHeight(130)
SSumText20:SetPoint("TOPLEFT", SSumFrame, "TOPLEFT", 215, -15)
SSumText20:SetJustifyH("RIGHT") SSumText20:SetJustifyV("TOP")
SSumText20:SetParent("SSumFrame")

SSumText3 = SSumFrame:CreateFontString(nil, "BACKGROUND")
SSumText3:SetFontObject(GameFontNormalSmall)
SSumText3:SetWidth(200) SSumText3:SetHeight(130)
SSumText3:SetPoint("TOPLEFT", SSumFrame, "TOPLEFT", 430, -15)
SSumText3:SetJustifyH("LEFT") SSumText3:SetJustifyV("TOP")
SSumText3:SetParent("SSumFrame")

SSumText30 = SSumFrame:CreateFontString(nil, "BACKGROUND")
SSumText30:SetFontObject(GameFontNormalSmall)
SSumText30:SetWidth(200) SSumText30:SetHeight(130)
SSumText30:SetPoint("TOPLEFT", SSumFrame, "TOPLEFT", 430, -15)
SSumText30:SetJustifyH("RIGHT") SSumText30:SetJustifyV("TOP")
SSumText30:SetParent("SSumFrame")

-- EVENT HANDLER
function ScoreboardSummary_OnEvent(event)
    if (event == "ADDON_LOADED") then
        SlashCmdList["ScoreboardSummary"] = ScoreboardSummary_ChatCommandHandler
        SLASH_ScoreboardSummary1 = "/ssum"
        SLASH_ScoreboardSummary2 = "/scoreboardsummary"
        SlashCmdList["ScoreboardSummarySpammer"] = ScoreboardSummary_Spammer
        SLASH_ScoreboardSummarySpammer1 = "/spam"
    end
end

-- CHAT HANDLER
function ScoreboardSummary_ChatCommandHandler(msg)
    if SSumFrame:IsVisible() then
        argv = {}; for arg in string.gmatch(string.lower(msg), '[%a%d%-%.]+') do table.insert(argv, arg) end
        
        local PlayerName, PlayerKillingBlows, PlayerHonorKills, PlayerDeaths, PlayerHonorGained, PlayerFaction, PlayerRank, PlayerRace, PlayerClass, PlayerFilename, PlayerDamageDone, PlayerHealingDone =
                "nil", 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        
        for i = 1, GetNumBattlefieldScores() do
            name, kb, hk, deaths, bonus, faction, rank, race, class, damage, healing = GetBattlefieldScore(i)
            if string.find(name, UnitName("player")) then
                PlayerName, PlayerKillingBlows, PlayerHonorKills, PlayerDeaths, PlayerHonorGained, PlayerFaction, PlayerRank, PlayerRace, PlayerClass, PlayerFilename, PlayerDamageDone, PlayerHealingDone = GetBattlefieldScore(i)
            end
        end
        if (argv[1] == nil) then
            DEFAULT_CHAT_FRAME:AddMessage("|cffffffffKilling Blows: |cffffd200".. PlayerKillingBlows ..
                                                " |cffff2020** |cffffffffHonor Kills: |cffffd200".. PlayerHonorKills ..
                                                " |cffff2020** |cffffffffDeaths: |cffffd200".. PlayerDeaths ..
                                                " |cffff2020** |cffffffffDamage Done: |cffffd200".. PlayerDamageDone ..
                                                " |cffff2020** |cffffffffHealing Done: |cffffd200".. PlayerHealingDone)
        elseif (argv[1] ~= nil) then
            SendChatMessage("Killing Blows: ".. PlayerKillingBlows ..
                            " ** Honor Kills: ".. PlayerHonorKills ..
                            " ** Deaths: ".. PlayerDeaths ..
                            " ** Damage Done: ".. PlayerDamageDone ..
                            " ** Healing Done: ".. PlayerHealingDone, "WHISPER", nil, argv[1])
        end
    else
        DEFAULT_CHAT_FRAME:AddMessage("The BG Score frame must be showing to use this feature!")
    end
end

function ScoreboardSummary_Spammer()
    if SSumFrame:IsVisible() then
        SendChatMessage("Scoreboard Summary v".. ScoreboardSummary_Version, "BATTLEGROUND")
        local name, faction, class, healers = nil, nil, nil, 0
        for i = 1, GetNumBattlefieldScores() do
            name, _, _, _, _, faction, _, _, class = GetBattlefieldScore(i)
            if (UnitFactionGroup("player") == "Horde") then
                if (faction == 1) then
                    if (class == "Priest") then healers = healers + 1; SendChatMessage("Priest: ".. name, "BATTLEGROUND") end
                    if (class == "Druid") then healers = healers + 1; SendChatMessage("Druid: ".. name, "BATTLEGROUND") end
                    if (class == "Paladin") then healers = healers + 1; SendChatMessage("Paladin: ".. name, "BATTLEGROUND") end
                    if (class == "Shaman") then healers = healers + 1; SendChatMessage("Shaman: ".. name, "BATTLEGROUND") end
                end
            end
            if (UnitFactionGroup("player") == "Alliance") then
                if (faction == 0) then
                    if (class == "Priest") then healers = healers + 1; SendChatMessage("Priest: ".. name, "BATTLEGROUND") end
                    if (class == "Druid") then healers = healers + 1; SendChatMessage("Druid: ".. name, "BATTLEGROUND") end
                    if (class == "Shaman") then healers = healers + 1; SendChatMessage("Paladin: ".. name, "BATTLEGROUND") end
                    if (class == "Paladin") then healers = healers + 1; SendChatMessage("Shaman: ".. name, "BATTLEGROUND") end
                end
            end
        end
        SendChatMessage("Total Healers: ".. healers, "BATTLEGROUND")
    else
        DEFAULT_CHAT_FRAME:AddMessage("The BG Score frame must be showing to use this feature!")
    end
end

-- FRAME ON UPDATE
function ScoreboardSummary_OnUpdate()
    if (WorldStateScoreFrame:IsVisible()) then
        local servers = {}
        local yourservers = {}
        local name, kb, hk, deaths, bonus, faction, rank, race, class, damage, healing, server2 =
                "nil", 0, 0, 0, 0, "nil", "nil", "nil", "nil", 0, 0, "nil"
        local priests, druids, warriors, paladins, warlocks, mages, hunters, rogues, shamans, healers, dps, count =
                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        local yourpriests, yourdruids, yourwarriors, yourpaladins, yourwarlocks, yourmages, yourhunters, yourrogues, yourshamans, yourhealers, yourdps, yourcount =
                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        local PlayerName, PlayerKillingBlows, PlayerHonorKills, PlayerDeaths, PlayerHonorGained, PlayerFaction, PlayerRank, PlayerRace, PlayerClass, PlayerFilename, PlayerDamageDone, PlayerHealingDone =
                "nil", 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        
        for i = 1, GetNumBattlefieldScores() do
            name, kb, hk, deaths, bonus, faction, rank, race, class, damage, healing = GetBattlefieldScore(i)
            
            if (UnitFactionGroup("player") == "Horde") then
                if (faction == 1) then
                    if (class == "Priest") then priests = priests + 1; healers = healers + 1 end
                    if (class == "Druid") then druids = druids + 1; healers = healers + 1 end
                    if (class == "Warrior") then warriors = warriors + 1; dps = dps + 1 end
                    if (class == "Paladin") then paladins = paladins + 1; healers = healers + 1 end
                    if (class == "Shaman") then shamans = shamans + 1; healers = healers + 1 end
                    if (class == "Warlock") then warlocks = warlocks + 1; dps = dps + 1 end
                    if (class == "Mage") then mages = mages + 1; dps = dps + 1 end
                    if (class == "Hunter") then hunters = hunters + 1; dps = dps + 1 end
                    if (class == "Rogue") then rogues = rogues + 1; dps = dps + 1 end 
                    if (name) then if (not string.find(name, "-")) then server2 = GetRealmName()
                    else _, server2 = strsplit("-", name, 2) end
                    if (servers[server2] == nil) then servers[server2] = 1; count = count + 1 end end
                end
                if (faction == 0) then
                    if (class == "Priest") then yourpriests = yourpriests + 1; yourhealers = yourhealers + 1 end
                    if (class == "Druid") then yourdruids = yourdruids + 1; yourhealers = yourhealers + 1 end
                    if (class == "Warrior") then yourwarriors = yourwarriors + 1; yourdps = yourdps + 1 end
                    if (class == "Paladin") then yourpaladins = yourpaladins + 1; yourhealers = yourhealers + 1 end
                    if (class == "Shaman") then yourshamans = yourshamans + 1; yourhealers = yourhealers + 1 end
                    if (class == "Warlock") then yourwarlocks = yourwarlocks + 1; yourdps = yourdps + 1 end
                    if (class == "Mage") then yourmages = yourmages + 1; yourdps = yourdps + 1 end
                    if (class == "Hunter") then yourhunters = yourhunters + 1; yourdps = yourdps + 1 end
                    if (class == "Rogue") then yourrogues = yourrogues + 1; yourdps = yourdps + 1 end
                    if (name) then if (not string.find(name, "-")) then server2 = GetRealmName()
                    else _, server2 = strsplit("-", name, 2) end
                    if (yourservers[server2] == nil) then yourservers[server2] = 1; yourcount = yourcount + 1 end end
                end
            end
            if (UnitFactionGroup("player") == "Alliance") then
                if (faction == 0) then
                    if (class == "Priest") then priests = priests + 1; healers = healers + 1 end
                    if (class == "Druid") then druids = druids + 1; healers = healers + 1 end
                    if (class == "Warrior") then warriors = warriors + 1; dps = dps + 1 end
                    if (class == "Shaman") then shamans = shamans + 1; healers = healers + 1 end
                    if (class == "Paladin") then paladins = paladins + 1; healers = healers + 1 end
                    if (class == "Warlock") then warlocks = warlocks + 1; dps = dps + 1 end
                    if (class == "Mage") then mages = mages + 1; dps = dps + 1 end
                    if (class == "Hunter") then hunters = hunters + 1; dps = dps + 1 end
                    if (class == "Rogue") then rogues = rogues + 1; dps = dps + 1 end
                    if (name) then if (not string.find(name, "-")) then server2 = GetRealmName()
                    else _, server2 = strsplit("-", name, 2) end
                    if (servers[server2] == nil) then servers[server2] = 1; count = count + 1 end end
                end
                if (faction == 1) then
                    if (class == "Priest") then yourpriests = yourpriests + 1; yourhealers = yourhealers + 1 end
                    if (class == "Druid") then yourdruids = yourdruids + 1; yourhealers = yourhealers + 1 end
                    if (class == "Warrior") then yourwarriors = yourwarriors + 1; yourdps = yourdps + 1 end
                    if (class == "Paladin") then yourpaladins = yourpaladins + 1; yourhealers = yourhealers + 1 end
                    if (class == "Shaman") then yourshamans = yourshamans + 1; yourhealers = yourhealers + 1 end
                    if (class == "Warlock") then yourwarlocks = yourwarlocks + 1; yourdps = yourdps + 1 end
                    if (class == "Mage") then yourmages = yourmages + 1; yourdps = yourdps + 1 end
                    if (class == "Hunter") then yourhunters = yourhunters + 1; yourdps = yourdps + 1 end
                    if (class == "Rogue") then yourrogues = yourrogues + 1; yourdps = yourdps + 1 end 
                    if (name) then if (not string.find(name, "-")) then server2 = GetRealmName()
                    else _, server2 = strsplit("-", name, 2) end
                    if (yourservers[server2] == nil) then yourservers[server2] = 1; yourcount = yourcount + 1 end end
                end
            end
            
            if name then if string.find(name, UnitName("player")) then
                PlayerName, PlayerKillingBlows, PlayerHonorKills, PlayerDeaths, PlayerHonorGained, PlayerFaction, PlayerRank, PlayerRace, PlayerClass, PlayerFilename, PlayerDamageDone, PlayerHealingDone = GetBattlefieldScore(i)
            end end
        end
        -- write data
        SSumText1:SetText("|cffffffff"..PlayerName..
                                        "\n|cffffffff Killing Blows: |cffffd200".. 
                                        "\n|cffffffff Honor Kills: |cffffd200".. 
                                        "\n|cffffffff Deaths: |cffffd200".. 
                                        "\n|cffffffff Bonus Honor: |cffffd200".. 
                                        "\n|cffffffff Damage Done: |cffffd200".. 
                                        "\n|cffffffff Healing Done: |cffffd200")
        SSumText2:SetText("|cffff2020Enemies|cffffffff - |cff20ff20Friends"..
                                        "\n|cffffffff Priests: |cffff2020".. 
                                        "\n|cffff7f00 Druids: |cffff2020".. 
                                        "\n|cffff3399 Paladans: |cffff2020".. 
                                        "\n|cff33cccc Shamans: |cffff2020".. 
                                        "\n|cffc7c7cf Total Healers: |cffff2020")
        SSumText3:SetText("|cffeda55f Warriors: |cffff2020".. 
                                        "\n|cff9980CC Warlocks: |cffff2020".. 
                                        "\n|cff00ffff Mages: |cffff2020".. 
                                        "\n|cff66cc99 Hunters: |cffff2020".. 
                                        "\n|cffffff00 Rogues: |cffff2020".. 
                                        "\n|cffc7c7cf Total DPS: |cffff2020".. 
                                        "\n \n|cffc7c7cf Server count:")
        SSumText10:SetText("\n".. PlayerKillingBlows ..
                                        "\n".. PlayerHonorKills ..
                                        "\n".. PlayerDeaths ..
                                        "\n".. PlayerHonorGained ..
                                        "\n".. PlayerDamageDone ..
                                        "\n".. PlayerHealingDone ..
                                        "\n \n")
        SSumText20:SetText("\n|cffff2020".. priests .."|cffffffff - |cff20ff20".. yourpriests ..
                                        "\n|cffff2020".. druids .."|cffffffff - |cff20ff20".. yourdruids ..
                                        "\n|cffff2020".. paladins .."|cffffffff - |cff20ff20".. yourpaladins ..
                                        "\n|cffff2020".. shamans .."|cffffffff - |cff20ff20".. yourshamans ..
                                        "\n|cffff2020".. healers .."|cffffffff - |cff20ff20".. yourhealers)
        SSumText30:SetText("|cffff2020".. warriors .."|cffffffff - |cff20ff20".. yourwarriors ..
                                        "\n|cffff2020".. warlocks .."|cffffffff - |cff20ff20".. yourwarlocks ..
                                        "\n|cffff2020".. mages .."|cffffffff - |cff20ff20".. yourmages ..
                                        "\n|cffff2020".. hunters .."|cffffffff - |cff20ff20".. yourhunters ..
                                        "\n|cffff2020".. rogues .."|cffffffff - |cff20ff20".. yourrogues ..
                                        "\n|cffff2020".. dps .."|cffffffff - |cff20ff20".. yourdps ..
                                        "\n \n|cffff2020".. count .."|cffffffff - |cff20ff20".. yourcount)
    end
end